searchNodes=[{"doc":"This module implements simple template of resource factory (ResourceFactory behaviour). It is for testing/debuging purpouse.","ref":"DefaultResourceFactory.html","title":"DefaultResourceFactory","type":"module"},{"doc":"Activate resource before starting to use.","ref":"DefaultResourceFactory.html#activate/2","title":"DefaultResourceFactory.activate/2","type":"function"},{"doc":"Create simple resource for testing. In real system new resource is created as process using resource metadata.","ref":"DefaultResourceFactory.html#create/1","title":"DefaultResourceFactory.create/1","type":"function"},{"doc":"Do nothing with test resource. Real system will close and dispose the resource.","ref":"DefaultResourceFactory.html#destroy/2","title":"DefaultResourceFactory.destroy/2","type":"function"},{"doc":"Passivate resource before going to idle.","ref":"DefaultResourceFactory.html#passivate/2","title":"DefaultResourceFactory.passivate/2","type":"function"},{"doc":"Test resource is always valid. Real system has to check health of given resource.","ref":"DefaultResourceFactory.html#validate/2","title":"DefaultResourceFactory.validate/2","type":"function"},{"doc":"The module defines a behaviour of resource factory.","ref":"ResourceFactory.html","title":"ResourceFactory","type":"behaviour"},{"doc":"Some action during activation of a resource before moving the resource from pool to client.","ref":"ResourceFactory.html#c:activate/2","title":"ResourceFactory.activate/2","type":"callback"},{"doc":"Creates new resource.","ref":"ResourceFactory.html#c:create/1","title":"ResourceFactory.create/1","type":"callback"},{"doc":"Destroyes a resource.","ref":"ResourceFactory.html#c:destroy/2","title":"ResourceFactory.destroy/2","type":"callback"},{"doc":"Some action during passivation of a resource after returning the resource from use to pool.","ref":"ResourceFactory.html#c:passivate/2","title":"ResourceFactory.passivate/2","type":"callback"},{"doc":"Validate resource: if resource is alive and valid then returns true, otherwise - false.","ref":"ResourceFactory.html#c:validate/2","title":"ResourceFactory.validate/2","type":"callback"},{"doc":"Facade for resource pool.","ref":"ResourcePool.html","title":"ResourcePool","type":"module"},{"doc":"Adds one more resource to pool (as an idle resource).","ref":"ResourcePool.html#add/1","title":"ResourcePool.add/1","type":"function"},{"doc":"Borrows resource from pool. Returns resource pid for client use.","ref":"ResourcePool.html#borrow/1","title":"ResourcePool.borrow/1","type":"function"},{"doc":"Disposes all resources from the pool.","ref":"ResourcePool.html#clear/1","title":"ResourcePool.clear/1","type":"function"},{"doc":"Disposes all resources from the pool and close the pool (shut down generic server).","ref":"ResourcePool.html#close/1","title":"ResourcePool.close/1","type":"function"},{"doc":"Returns number of active (busy) resources in pool.","ref":"ResourcePool.html#get_num_active/1","title":"ResourcePool.get_num_active/1","type":"function"},{"doc":"Returns number of idle (ready to use) resources in pool.","ref":"ResourcePool.html#get_num_idle/1","title":"ResourcePool.get_num_idle/1","type":"function"},{"doc":"Returns total number of resources in pool as a tuple {active, idle}.","ref":"ResourcePool.html#get_number/1","title":"ResourcePool.get_number/1","type":"function"},{"doc":"Invalidates resource - makes it ready to dispose.","ref":"ResourcePool.html#invalidate/2","title":"ResourcePool.invalidate/2","type":"function"},{"doc":"Creates and runs new generic server for ResourcePool with registered name pool_name. The new resource pool will use factory_module as a resource factory and resource_metadata as a metadata to create a new resource.","ref":"ResourcePool.html#new/3","title":"ResourcePool.new/3","type":"function"},{"doc":"Creates and runs new generic server for ResourcePool with registered name pool_name. The new resource pool will use factory_module as a resource factory and resource_metadata as a metadata to create a new resource. options defines behaviour of the pool. The available options are:max_active: integer() - defines the maximum number of resource instances that can be allocated by the pool at a given time. If non-positive, there is no limit to the number of instances that can be managed by the pool at one time. When max_active is reached, the pool is said to be exhausted. The default setting for this parameter is 8.max_idle: integer() defines the maximum number of objects that can sit idle in the pool at any time. If negative, there is no limit to the number of objects that may be idle at one time. The default setting for this parameter equals max_active.min_idle: integer() defines the minimum number of &quot;sleeping&quot; instances in the pool. Default value is 0.test_on_borrow: boolean() If true the pool will attempt to validate each resource before it is returned from the borrow function (Using the provided resource factory's validate function). Instances that fail to validate will be dropped from the pool, and a different object will be borrowed. The default setting for this parameter is false.test_on_return: boolean() If true the pool will attempt to validate each resource instance before it is returned to the pool in the return function (Using the provided resource factory's validate function). Objects that fail to validate will be dropped from the pool. The default setting for this option is false.fifo: boolean() The pool can act as a LIFO queue with respect to idle resource instances always returning the most recently used resource from the pool, or as a FIFO queue, where borrow always returns the oldest instance from the idle resource list. fifo determines whether or not the pool returns idle objects in first-in-first-out order. The default setting for this parameter is false.when_exhausted_action: (:fail | :block | :grow) specifies the behaviour of the borrow function when the pool is exhausted::fail will return an error.:block will block until a new or idle object is available. If a positive max_wait value is supplied, then borrow will block for at most that many milliseconds, after which an error will be returned. If max_wait is non-positive, the borrow function will block infinitely.:grow will create a new object and return it (essentially making max_active meaningless.) The default when_exhausted_action: setting is :block and the default max_wait: setting is :infinity. By default, therefore, borrow will block infinitely until an idle instance becomes available.max_wait: (integer() | infinity) The maximum amount of time to wait when the borrow function is invoked, the pool is exhausted (the maximum number of &quot;active&quot; resource instances has been reached) and when_exhausted_action: equals :block.max_idle_time: (integer() | infinity) The maximum amount of time an resource instance may sit idle in the pool, with the extra condition that at least min_idle amount of object remain in the pool. When infinity, no instances will be evicted from the pool due to maximum idle time limit.","ref":"ResourcePool.html#new/4","title":"ResourcePool.new/4","type":"function"},{"doc":"The function sends resource to the pool's idle container after client does not need it any more.","ref":"ResourcePool.html#return/2","title":"ResourcePool.return/2","type":"function"},{"doc":"The module ResourcePool.GenServer implements resource pool functionality.","ref":"ResourcePool.GenServer.html","title":"ResourcePool.GenServer","type":"module"},{"doc":"handle message :borrowhandle message {:ack_borrow, {:error, :pool_timeout}}","ref":"ResourcePool.GenServer.html#handle_call/3","title":"ResourcePool.GenServer.handle_call/3","type":"function"},{"doc":"Takes argument tuple of options, factory_module and resource_metadata.","ref":"ResourcePool.GenServer.html#init/1","title":"ResourcePool.GenServer.init/1","type":"function"},{"doc":"Resource Pool - Getting started","ref":"readme.html","title":"Resource Pool - Getting started","type":"extras"},{"doc":"Resource pool (rsrc_pool_ex)project is written in Elixir as a tiny library. The goal of the tool is reduce the overhead of creating new resources by reusing of the same resources among multiple processes. Achieving result is better performance and throughput. The resource pool was inspired by Java Apache's commons pool and adopts API and main principals from this project. Database connection is most popular example for pooling resource.","ref":"readme.html#summary","title":"Resource Pool - Getting started - Summary","type":"extras"},{"doc":"Resource pool project was inspired by Apache Commons Pool library and API was borrowed from there. But internal implementation is completely different, written in Elixir and it is using Erlang OTP design principles and Erlang concurrent model. Resource Pool is Elixir application library.","ref":"readme.html#introduction","title":"Resource Pool - Getting started - Introduction","type":"extras"},{"doc":"ResourcePool.GenServer (resource_pool_srv.ex) is a main module of Resource Pool. It is generic server and implements almost all Pool functionality.ResourcePool (resource_pool.ex) is a facade for GenServer and exposes all API functions.ResourceFactory (resource_factory.ex) defines ResourceFactory behaviour.","ref":"readme.html#structure","title":"Resource Pool - Getting started - Structure","type":"extras"},{"doc":"Create instance of Resource Pool{:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, [])where: :test_pool - registered name of the new pool;ResourceFactory - name of a module that implements ResourceFactory behaviour. New resource pool is usually shared between few processes. Borrow resource from poolresource = ResourcePool.borrow(:test_pool)The process can use the borrowed resource and has to return to pool after finish. Return resource to pool:ok = ResourcePool.return(:test_pool, resource)The process cannot use the resource anymore.Pool can be created with options:options = [max_active: 10, when_exhausted_action: fail] {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, options)See ResourcePool for more details about options.See Resource Pool article for details and http://erlpool.sourceforge.net/.","ref":"readme.html#getting-started","title":"Resource Pool - Getting started - Getting started","type":"extras"},{"doc":"If available in Hex, the package can be installed by adding rsrc_pool_ex to your list of dependencies in mix.exs:def deps do [ {:rsrc_pool_ex, &quot;~&gt; 0.1.0&quot;} ] endDocumentation can be generated with ExDoc and published on HexDocs. Once published, the docs can be found at https://hexdocs.pm/rsrc_pool_ex.","ref":"readme.html#installation","title":"Resource Pool - Getting started - Installation","type":"extras"},{"doc":"Resource Pool - article","ref":"readme_1.html","title":"Resource Pool - article","type":"extras"},{"doc":"Some software resources have time and memory cost to create and reusing them can dramatically improve application performance. Resource pooling is widely used for resource reusing in different platform and languages. This project was inspired by Apache Commons Pool Java library. API and main functioning principals was borrowed from there, but internal implementation is completely different and is using Erlang OTP design principles and Erlang/Elixir concurrent model. See Erlang resource pool for Erlang implementation of the library.","ref":"readme_1.html#introduction","title":"Resource Pool - article - Introduction","type":"extras"},{"doc":"Resource pool consists of two containers: Active and Idle. Active container keeps references to resources that are actively used by some processes. Oppositely Idle container keeps resources that are not used anywhere and they are in inactive state but ready to use. +-Pool-----------{0,0}-+ | | | Active--+ Idle----+ | | | | | | | | | | | | | | | | | | | | +-------+ +-------+ | +----------------------+We will use a diagram above to explain operations with pool in following text. Symbols in right of first line -{0,0}- show the load of containers: -{N_active,N_idle}-,where:N_active - number of active resources;N_idle - number of idle resources.","ref":"readme_1.html#design","title":"Resource Pool - article - Design","type":"extras"},{"doc":"First thing we have to do is create an instance of resource pool. {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, resource_metadata):test_pool is a registered name for the new pool and ResourceFactory is a name of a module that implements resource_factory behaviour. Now we can use :test_pool or pid as a reference to pool instance. Resource factory module will be responsible for creating, checking and disposing of resource instances and is discussed in details in Resource factory section below.The common scenario of using of the resource pool is state with a few concurrently running processes shares the same pool to borrow resources from it.borrowTo retrieve a resource from pool process has to call function borrow. resource = ResourcePool.borrow(:test_pool)If Idle list is empty the pool creates new resource &lt;R.2&gt; and grants it to calling process. +-Pool-----------{1,0}-+ +-Pool-----------{2,0}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | | | | | | | | | | | | | | | =&gt; | | &lt;R.2&gt; | | | | | | &lt;R.1&gt; | | | | | | &lt;R.1&gt; | | | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+If the pool has idle resource within Idle list an idle resource just transfers to Active list and it is granted to caling process. +-Pool-----------{1,2}-+ +-Pool-----------{2,1}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | | | | | | | | | | | | | &lt;R.2&gt; | | =&gt; | | &lt;R.2&gt; | | | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+returnProcess has to return a resource to the pool after the process completes using a resource. In other words the resource is moved from Active list to Idle list. Now other concurrent processes can borrow freed resource from the pool. ResourcePool.return(:test_pool, resource) +-Pool-----------{2,1}-+ +-Pool-----------{1,2}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | | | | | | | | | | | &lt;R.2&gt; | | | | =&gt; | | | | &lt;R.2&gt; | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+addSometimes we need just add new resource to pool. Function add creates new resource and puts it into Idle list. ResourcePool.add(:test_pool) +-Pool-----------{2,1}-+ +-Pool-----------{2,2}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | | | | | | | | | | | &lt;R.2&gt; | | | | =&gt; | | &lt;R.2&gt; | | &lt;R.4&gt; | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+invalidateIf resource failed then a process has to let know about it to the pool. invalidate function marks failed resource as unusable and pool will destroy it shortly. ResourcePool.invalidate(:test_pool, resource) +-Pool-----------{2,1}-+ +-Pool-----------{1,1}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | | | | | | | | | | | &lt;R.2&gt; | | | | =&gt; | | | | | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | | &lt;R.1&gt; | | &lt;R.3&gt; | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+typical use caseSuppose that Resource module implements some operations under resource. case ResourcePool.borrow(:test_pool) do {:error, e} -&gt; IO.put(&quot;Error while borrow from pool, reason: \#{e}&quot;) resource -&gt; try do Resource.operation(resource) ResourcePool.return(:test_pool, resource) catch _ -&gt; ResourcePool.invalidate(:test_pool, resource) end endIf everything is going well we see flow like this: borrow --&gt; use --&gt; return. When something wrong is happened during resource use then we have other flow: borrow --&gt; use --&gt; invalidate.","ref":"readme_1.html#operations","title":"Resource Pool - article - Operations","type":"extras"},{"doc":"We can setup some features and parameters for a resource pool during instantiation by using option parameter of new operation (see new): {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, resource_metadata, options)options list contains a few values those define scales, limitation and behavior of a pool. Some of those are responsible for size of Active and Idle containers: max_active, max_idle, min_idle +-Pool-----------{0,0}-+ | | | Active--+ Idle----+ | | | | |_______|_|__ max_idle max_active__|_|_______| | | | | | | | | | | | | |_______|_|__ min_idle | | | | | | | +-------+ +-------+ | +----------------------+max_activeMaximum size of Active list is 8 by default. If it reaches the limit following borrow operation will be blocked or failed (see Borrow with exhausted pool for details). The value -1 (or any negative) means no limitation on Active list size. Example of use: {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, [], [max_active: 20])max_idleMaximum size of Idle list equals max_active by default. If it reaches the limit then following return operation will be finished with destroying of the returned resource. The value -1 (or any negative) means no limitation on Idle list maximum size. Example of use: {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, [], [max_active: 20, max_idle: 10])min_idleMinimum size of Idle list is 0 by default. If it reaches the limit then following borrow operation will successfully supplies a resource to invoker and then pool will additionally create new resource in Idle container to provide min_idle condition. The value -1 (or any negative) means no limitation on Idle list minimum size. Example of use: {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, [], [max_active: 20, max_idle: 10, min_idle: 3])","ref":"readme_1.html#size-limits","title":"Resource Pool - article - Size limits","type":"extras"},{"doc":"Borrow with exhausted poolWhen we set max_active greater then 0 and size of Active list reaches this value then the pool is exhausted and pool's behaiviour depends on when_exhausted_action option value: - borrow function on exhausted pool returns {:error, :pool_exhausted}. - borrow function on exhausted pool is blocked until a new or idle object is available. Waiting time period is limited by value of other option max_wait (see Timing). - borrow function on exhausted pool returns new resource and size of Active list grows. In this case max_active option is just ignored.Default value is block. Example of use: {:ok, pid} = ResourcePool.new(:test_pool, ResourceFactory, [], [max_active: 20, when_exhausted_action: fail])Resource checkingResource pool can check status of managed resources. Options test_on_borrow and test_on_return control how pool tests resources: before providing resource to invoker test_on_borrow: true and after a resource was returned to pool test_on_return: true. If pool finds that the resource is not alive during test then the resource will be destroyed.Resource order in idle containerOption fifo (first-input-first-output) controls order of extracting a resources from Idle list. Diagrams below illustrate this. Suppose we fill out Idle list in order: &lt;R.1&gt; was first, &lt;R.2&gt; is next, then &lt;R.3&gt;. Resource &lt;R.4&gt; is active in given moment. If fifo: true is set the borrow operation leads to situation below: resource &lt;R.1&gt; was came first and it becomes active now (first out). +-Pool-----------{1,2}-+ +-Pool-----------{2,1}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | &lt;R.3&gt; | | | | | | | | | | | | &lt;R.2&gt; | | =&gt; | | &lt;R.1&gt; | | &lt;R.3&gt; | | | | &lt;R.4&gt; | | &lt;R.1&gt; | | | | &lt;R.4&gt; | | &lt;R.2&gt; | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+If fifo: false is set it means that order will be last-input-first-output. borrow operation makes active resource &lt;R.3&gt; (last input). +-Pool-----------{1,2}-+ +-Pool-----------{2,1}-+ | | | | | Active--+ Idle----+ | | Active--+ Idle----+ | | | | | &lt;R.3&gt; | | | | | | | | | | | | &lt;R.2&gt; | | =&gt; | | &lt;R.3&gt; | | &lt;R.2&gt; | | | | &lt;R.4&gt; | | &lt;R.1&gt; | | | | &lt;R.4&gt; | | &lt;R.1&gt; | | | +-------+ +-------+ | | +-------+ +-------+ | +----------------------+ +----------------------+Default value for fifo is false.Timingmax_wait option defines the maximum amount of time to wait when the borrow function is invoked, the pool is exhausted and when_exhausted_action equals block. max_idle_time option defines non terminated period of time an resource instance may sit idle in the pool, with the extra condition that at least min_idle amount of object remain in the pool. No resources will be evicted from the pool due to maximum idle time limit if max_idle_time equals infinity.","ref":"readme_1.html#behaviour-options","title":"Resource Pool - article - Behaviour options","type":"extras"},{"doc":"newLets look more closely at resource pool instantiation. pool_name is atom and multiple processes can use the registered name to access the resource pool. ResourceFactory is module name that is responsible for creating and maintenance of a resources. resource_metadata is an object that contains information for instantiation of an resource. The object is passed as parameter to each function of resource_factory to help maintain an resources. {:ok, pid} = ResourcePool.new(:pool_name, ResourceFactory, resource_metadata)clearThe function sweep up (destroy) all resources from pool. :ok = ResourcePool.clear(:pool_name)closeThe function terminates pool process and destroys all resources from pool. :ok = ResourcePool.close(:pool_name)get_num_active, get_num_idle, get_numberThe functions return number of resources in Active, Idle containers and total number of resources.","ref":"readme_1.html#maintenance-of-pool-instance","title":"Resource Pool - article - Maintenance of pool instance","type":"extras"},{"doc":"Before we do not go in details of an resources managed by pool. We was thinking about its as abstract resource without any features and properties. It is not true in reality. Real resources (as connections, sockets, channels and so on) are living in pool are composed objects with number of properties and they have an life cycle: we have to create them, test, use and dispose them. Resource factory separate pool functionality from managed resources functionality and allows to easy customize pool for different types of resources.ResourceFactory module defines behavior of generic resource factory. We have to implement this behavior while designing of resource factory module for given resource. The module has to consist following functions:create(resource_metadata :: list()) - The function creates new instance of the resource. In Elixir world this is a new process in most cases. resource_metadata is a data structure that describes an resource. resource_metadata came to the pool from new operation and it has to be enough to create and manage the resource. Structure and contain of the resource_metadata is custom and it is used only by ResourceFactory but is kept as a pool state.destroy(resource_metadata :: term(), resource :: pid()) - The function destroys the resource represented by resource as a Pid.validate(resource_metadata :: term(), resource :: pid()) - The function check an resource and returns true if the resource is valid.activate(resource_metadata :: term(), resource :: pid()) - The function is callback that is fired when pool are moving resource from passive state to active (from idle list to active list).passivate(resource_metadata :: term(), resource :: pid()) - The function is callback that is fired when pool are moving resource from active state to passive (from active list to idle list).","ref":"readme_1.html#resource-factory","title":"Resource Pool - article - Resource factory","type":"extras"}]